// CommandSink.h : CCommandSink ̐錾

#ifndef __COMMANDSINK_H_
#define __COMMANDSINK_H_

#include "resource.h"       // C V{
#include "sari_i.h"


/////////////////////////////////////////////////////////////////////////////
// CCommandSink
class ATL_NO_VTABLE CCommandSink : 
	public CComObjectRootEx<CComSingleThreadModel>,
//	public CComCoClass<CCommandSink, &CLSID_CommandSink>,
	public IDispatchImpl<ICommandSink, &IID_ICommandSink, &LIBID_AD_ALMLLib>
{
public:
	CCommandSink()
	{
        m_pApl=NULL;
        m_dwCookie=0;
        m_dwAdvise=0;
		m_csModuleDir=_T("");
		m_csAlMailPath=_T("");
	}
    ISRAPL *m_pApl;
     DWORD m_dwCookie;
     DWORD m_dwAdvise;


	CString m_csModuleDir;
	CString m_csAlMailPath;

// DECLARE_REGISTRY_RESOURCEID(IDR_COMMANDSINK)
DECLARE_NOT_AGGREGATABLE(CCommandSink)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCommandSink)
	COM_INTERFACE_ENTRY(ICommandSink)
	COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY_IID(DIID__ISRAPLEvents, IDispatch)
END_COM_MAP()


	void GetModuleDir();
	void OnSendMailToAlMail();
	void ChangeDelimita(CString& csSTR, TCHAR cOld, TCHAR cNew);
	BOOL GetAlMailPath(BOOL bNeedInput=FALSE);
	BOOL BootAlMail(LPCTSTR lpFilePath);
	

	


// ICommandSink
public:
	STDMETHOD(OnCloseInstance)();
	STDMETHOD(OnPostSave)();
	STDMETHOD(OnPreSave)();
	STDMETHOD(OnPostOpen)();
	STDMETHOD(OnPreOpen)();
	STDMETHOD(OnNewInstance)();
	STDMETHOD(OnAddinCommand)(/*[in]*/long lCookie, /*[in]*/long lInnerNumber);

public:
    BOOL SetObjectInfo(ISRAPL *pApl, DWORD dwCookie);
    void Unadvise();
	
	
};

#endif //__COMMANDSINK_H_
